<template>
    <div class="app-container">
        <el-row :gutter="20" type="flex" justify="center" align="middle">
            <el-col :lg="23" :md="23" :sm="24" align="middle" class="paper">
                <div class="filter-container">
                    <el-row :gutter="20">
                        <el-col :span="6" class="text-align-left">
                            <h3>Permissions</h3>
                        </el-col>
                        <el-col :span="18">
                            <el-row :gutter="20">
                                <el-col :lg="14" :md="14" :sm="24">
                                    <el-input 
                                        prop="keyword" 
                                        v-model="filter.keyword" 
                                        ref="keyword" 
                                        name="keyword" 
                                        placeholder="Permission's name" 
                                        size="large" 
                                        class="filter-item width-100" 
                                        clearable 
                                        @keyup.enter.native="getPermissions(1, false)" 
                                        @clear="getPermissions(1, false)"/>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button @click="getPermissions(1, false)" size="small" type="primary" class="filter-item width-100" style="font-size:14px;">
                                        <i class="ion-ios-search"></i> Search
                                    </el-button>
                                </el-col>
                                <el-col :lg="5" :md="5" :sm="24">
                                    <el-button size="medium" type="success" class="filter-item width-100" style="font-size:14px;" @click="handleAddNew">
                                        <i class="ion-ios-add-circle"></i> Add
                                    </el-button>
                                </el-col>
                            </el-row>
                        </el-col>
                    </el-row>
                </div>
                <el-table v-loading="tableLoading" :data="permissions" style="width: 100%" :height="tableHeight()" fit highlight-current-row v-infinite-scroll="loadMore">
                    <el-table-column
                        fixed="left"
                        label="Name"
                        width="200">
                        <template slot-scope="scope">
                            <span style="color:#3E89FA;">{{ scope.row.name }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Description"
                        width="300">
                        <template slot-scope="scope">
                            <span>{{ scope.row.description }}</span>
                        </template>
                    </el-table-column>
                    <el-table-column
                        label="Last Updated"
                        width="150">
                        <template slot-scope="scope">
                            {{ dateFormat(scope.row.updated) }}
                        </template>
                    </el-table-column>
                    <el-table-column
                        fixed="right"
                        label="Action"
                        min-width="200">
                        <template slot-scope="{row}">
                            <el-button v-permission="[row, 'permission', 'viewother']" type="text" @click="handleEdit(row)">Edit</el-button>
                            <el-button v-permission="[row, 'permission', 'deleteother']" type="text" class="text-danger" @click="handleDelete(row)">Delete</el-button>
                        </template>
                    </el-table-column>
                </el-table>

                <el-dialog v-loading="dialogLoading" :title="dialogTitle[dialogStatus]" :visible.sync="showDialog" width="40%" :show-close="false" @closed="resetForm">
                    <el-form ref="permissionForm" :model="permissionForm" :rules="permissionRules">
                        <aside>
                            <el-alert type="info" description="Add or edit module access permission" :closable=false show-icon></el-alert>
                        </aside>
                        <el-form-item label="Name" prop="name">
                            <el-input ref="name" name="name" v-model="permissionForm.name" placeholder="Permission name" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                        </el-form-item>
                        <el-form-item label="Description" prop="description">
                            <el-input ref="description" name="description" v-model="permissionForm.description" placeholder="Description" autocomplete="off" maxlength="255" class="has-suffix" show-word-limit></el-input>
                        </el-form-item> 
                    </el-form>
                    <span slot="footer" class="dialog-footer">
                        <el-button @click="showDialog = false" size="medium"><i class="ion-ios-close-circle-outline"></i> Cancel</el-button>
                        <el-button v-permission="[null, 'permission', 'editother']" @click="handleSubmit" size="medium" type="success">
                            <i class="ion-ios-checkmark-circle"></i> {{ dialogTitle[dialogStatus] }}
                        </el-button>
                    </span>
                </el-dialog>
            </el-col>
        </el-row>
    </div>
</template>
<script>
import { mapGetters } from 'vuex';
import permission from '@/directive/permission/index.js';
import { parseError, dateFormat, tableHeight } from '../../utils/index';
export default {
    name: 'Permissions',
    directives: {
        permission
    },
    data(){
        return{
            tableLoading: false,
            dialogLoading: false,
            showDialog: false,
            dialogStatus: '',
            dialogTitle: {
                edit: 'Edit Permission',
                add: 'Add New Permission'
            },
            filter: {
                keyword: ''
            },
            permissionForm: {
                id: null,
                name: '',
                description: ''
            },
            permissionRules: {
                name: [{ 
                    required: true, message: 'Permission name is required', trigger: 'blur'
                }, {
                    max: 255, message: 'Permission name length 255 characters', trigger: 'blur'
                }, {
                    pattern: /^([a-zA-Z\s]{1,255})$/, 
                    message: 'Only letters and spaces are allowed.', 
                    trigger: 'blur'
                }],
                description: [{ 
                    max: 255, 
                    message: 'Description length maximum 255 characters', 
                    trigger: 'blur'
                }]
            },
        }
    },
    computed:{
        ...mapGetters('auth', ['user']),
        ...mapGetters('permission', [
            'permissions',
            'pagination'
        ])
    },
    created(){
        const self = this;

        self.getPermissions(1, false);
    },
    methods: {
        dateFormat,
        tableHeight,
        getPermissions(page, loadmore){
            const self = this;

            self.tableLoading = true;

            let params = {
                page: page,
                perpage: 25,
                loadmore: loadmore
            };

            if(self.filter.keyword.trim().length > 0){
                params.q = self.filter.keyword;
            }

            self.$store.dispatch('permission/getPermissions', params).then(()=>{
                self.tableLoading = false;
            });
        },
        loadMore(){
            const self = this;
            
            if(self.pagination.has_next){    
                self.getPermissions(self.pagination.page + 1, true);
            }
        },
        handleAddNew(){
            const self = this;
            self.dialogStatus = 'add';
            self.showDialog = true;          
            self.$nextTick(() => {
                self.$refs['permissionForm'].clearValidate();
            });
        },
        handleEdit(permission){
            const self = this;
            self.dialogStatus = 'edit';
            self.showDialog = true;

            self.permissionForm.id = permission.id;
            self.permissionForm.name = permission.name;
            self.permissionForm.description = permission.description;

            self.$nextTick(() => {
                this.$refs['permissionForm'].clearValidate();
            });
        },
        handleDelete(permission){
            const self = this;

            self.$confirm('You are about to delete this permission. This operation will affecting some modules become malfunction and this operation cannot be undone. Are you sure?', 'Warning', {
                confirmButtonText: 'Yes, I\'m Sure',
                cancelButtonText: 'Cancel'
            }).then(()=>{
                self.tableLoading = true;
                self.$store.dispatch('permission/deletePermission', {
                    id: permission.id
                }).then((response) => {
                    self.tableLoading = false;
                    if('errors' in response){
                        let error = parseError(response.errors);
                        self.$message.error({
                            message: error.messages
                        });
                    }else{
                        self.$message.success({
                            message: response.message
                        });
                    }
                });
            });
        },
        handleSubmit(){
            const self = this;

            self.$refs.permissionForm.validate((valid)=>{
                if(valid){
                    self.dialogLoading = true;

                    let action = 'permission/addPermission';
                    let params = {
                        name: self.permissionForm.name,
                        description: self.permissionForm.description
                    };

                    if(self.dialogStatus == 'edit'){
                        action = 'permission/editPermission';
                        params.id = self.permissionForm.id;
                    }

                    self.$store.dispatch(action, params).then((response)=>{
                        self.dialogLoading = false;

                        if('errors' in response){
                            let error = parseError(response.errors);
                            self.$message.error({
                                message: error.messages
                            });
                        }else{
                            self.showDialog = false;
                            self.$message.success({
                                message: response.message
                            });

                            self.resetForm();
                        }
                    });
                }else{
                    return false;
                }
            });
        },
        resetForm() {
            const self = this;

            self.permissionForm = {
                id: null,
                name: '',
                description: ''
            };
        },
    }
}
</script>